package eu.hsrw.tr.prog.vl.arrays;

public class Arrays {
	
	public static void main(String[] args) {
		
/**
 * Beispiele für Initialisierungen, schrittweise im Debugger ausführen und
 * Werte der Variablen ansehen
 */
		int[] a;
		a = new int[5];
		a[0] = 42;
		
		
		int[] b = {9, 14, 3, 7, 3};
		
		
		int[] c;
		// unzulässig:
		// c = {1, 7, 9, 2};
		
/**
 *  Minimum eines integer Arrays bestimmen
 */
		int[] zahlen = {4, 0, -3, 7, 2};
		
		// Ergebnis, wird mit erstem Wert des Arrays initialisiert
		int min = zahlen[0];
		
		// Position des Ergebnisses, wird mit erstem Index initialisiert
		int minpos = 0;
		
		// Array durchlaufen
		for (int i = 0; i < zahlen.length; i++) {
			// Prüfen, ob der aktuelle Wert ein neues Minimum ist
			if (zahlen[i] < min) {
				// Minimum aktualisieren
				min = zahlen[i];
				// Position ebenfalls sichern
				minpos = i;
			}
		}
		
		System.out.println("Minimum: " + min + " an Position [" + minpos + "]");

/**
 * Primzahlen mit dem Sieb des Eratosthenes finden
 */
		// Marker für Primzahlen
		boolean[] prim = new boolean[200];

		// Array initialisieren
		// Alle Zahlen werden vorerst als prim betrachtet: setzte auf true
		for (int i = 0; i < prim.length; i++) {
			prim[i] = true;
		}
	
	    // Vielfache der Primzahlen streichen, beginne bei 2
		for (int i = 2; i < prim.length; i++) {
			// ist die aktuelle zahl eine Primzahl?
			if (prim[i]) {
				// ja, ausgeben
				System.out.print(i + " ");
				
				// Vielfache streichen
				for (int j = i + i; j < prim.length; j = j + i) {
					prim[j] = false;
				}
			}
		}
	}
}
