package eu.hsrw.tr.prog.vl.methoden;

import java.util.Scanner;

/**
 * Demonstration der Deklaration und Verwendung von Methoden
 * 
 * @author Thomas Richter
 *
 */
public class Methoden {
	// Ausgabe(!!!) der Zeichenkette "hallo" auf der Konsole
	public static void schreibeHallo() {
		System.out.println("hallo");
	}
	
	// Ausgabe(!!!) von Sternen entsprechend des Wertes des Parameters n
	public static void schreibeSterne (int n) {
		// die Initialisierung könnte auch lauten i = 0 und die Bedingung wäre dann i < n
		for (int i = 1; i <= n; i++) {
			System.out.print("*");
		}
		// abschließend ein Umbruch
		System.out.println();
	}
	
	// Rückgabe(!!!) der Fakultät des Parameters n (n!)
	public static int fakultaet(int n) {
		int f = 1;
		for (int i = 1; i <= n; i++) {
			f = f * i;
		}
		return f;
	}
	
	// Rückgabe des größten gemeinsamen Teilers der beiden Parameter
	public static int ggT(int a, int b) {
		while (a != b) {
			if (a > b) {
				a = a - b;
			} else {
				b = b - a;
			}
		}
		return a;
	}
	
	public static void main(String[] args) {

		schreibeHallo();
	
		schreibeSterne(3);
		schreibeSterne(17 + 4);
		
		int m = fakultaet(4);
		
		schreibeSterne(m - 10);
		
		schreibeSterne(fakultaet(3));
		
		Scanner scan = new Scanner(System.in);
		System.out.print("erste Zahl: ");
		int x = scan.nextInt();

		System.out.print("zweite Zahl: ");
		int y = scan.nextInt();
		
		int z = ggT(x, y);
		System.out.println("ggT(" + x + ", " + y + ") = " + z);
	}
}